package platoto;
import java.util.*;

public class PlateauReactif extends Plateau {

    public abstract class Reaction {
	public abstract void onAdd (Object o, CaseReactive s));
    }

    public class CaseReactive extends Case {
	private List<Reaction> observers;
	
	public CaseReactive (int i) {
	    super (i);
	    observers = new LinkedList<Reaction> ();
	}

	public void register (Reaction r) {
	    observers.add (r);
	}
	
	public void add (Object o) {
	    for (Reaction r : observers) {
		r.onAdd (o);
	    }
	}
    }

    public PlateauReactif (int l,int n) {
	super (l, n);
    }

    
}
